<!DOCTYPE html>
<html lang="en" style="height:100%">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="https://dev.chatbot.drezy.io/frontend/asset/Bootstrap5/Bootstrap5.css" rel="stylesheet">
    <link rel="shortcut icon" type="image/png" href="https://dev.chatbot.drezy.io/frontend/img/bot-icon.png"/>
    <script src="https://dev.chatbot.drezy.io/frontend/asset/FontAwesome/font-awesome.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/crypto-js/3.1.9-1/crypto-js.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/crypto-js/3.1.9-1/hmac-sha256.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/crypto-js/3.1.9-1/enc-base64.min.js"></script>
    <title>Chat App</title>
</head>
<body style="height:100%">
    
    <div class="row" style="height:100%">
        <div class="col col-md-4" style="background-image: url('https://dev.chatbot.drezy.io/frontend/img/bgImg-2.png');">
            <div class="row d-flex justify-content-center" style="height:25% !important; text-align: center;">
                <p class="m-3"><img class="displayPicture" src="https://dev.chatbot.drezy.io/frontend/img/images.jfif"></p>
                <p class="m-0">
                   <span class="ps-2 pe-2 pt-1 pb-1" style="background-color: white;"> Name : <span id="displayName"></span> </span>
                </p>
                <p style="margin-top: 6px;">
                    <a href="#" style="margin-top: 6px;" onclick="app.logout();"><i class="fa fa-power-off logout" aria-hidden="true"></i></a>
                </p>
            </div>
            <div class="row" style="height:75% !important;">
                <div id="contactlist" class="p-1 m-3" style="height:430px; overflow: auto;">
                    <div class="contact-widget m-1 d-flex">
                        <div class="d-flex align-items-center justify-content-center" style="width:30%; height:100%">
                            <img src="https://dev.chatbot.drezy.io/frontend/img/bot-icon.png" class="guest-img">
                        </div>
                        <div style="width:70%; text-align: left;" onclick = "app.selectChat(sessionStorage.userID,sessionStorage.username);">
                            <div class="ms-1 mt-2"><b>Bot</b></div>
                            <p class="ms-1 summary">Hello</p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="col col-md-8">
            <div class="row d-flex justify-content-center align-items-center" 
            style="height:90% !important; background-image: url('https://dev.chatbot.drezy.io/frontend/img/background-img.jpg');">
                <div><h3 id=chatUser></h3></div>
                <div class="msg-container" id="msgConteiner">

                </div>
            </div>
            <div class="row d-flex align-items-center" style="height:10% !important; background-image:url('https://dev.chatbot.drezy.io/frontend/img/bgImg-2.jpg');">
                <div class="col-10">
                    <input id="textInput" type="text" class="form-control ms-3" name="msg" placeholder="Message" onkeyup="app.enterSendMessage(event)">
                </div>
                <div class="col-2">
                    <button class="btn btn-dark form-control" onclick="app.sendMessage()"><i class="fa fa-paper-plane me-1"></i>send</button>
                </div>
            </div>
        </div>
       
    </div>

</body>
</html>
<script src="/bot/socketIO/socket.io.js"></script>
<script>

const UAT = "https://dev.chatbot.drezy.io";
const LOCAL = "http://localhost:3333";
const BASE_URL = UAT;
const SOCKET_URL = BASE_URL+"/NS_DHSN";
    class Simulation{
        static randomText(){
            var loremIpsum = `At vero eos et accusamus et iusto odio dignissimos ducimus qui blanditiis praesentium voluptatum deleniti atque corrupti quos dolores et quas molestias excepturi sint occaecati cupiditate non provident, similique sunt in culpa qui officia deserunt mollitia animi, id est laborum et dolorum fuga. Et harum quidem rerum facilis est et expedita distinctio. Nam libero tempore, cum soluta nobis est eligendi optio cumque nihil impedit quo minus id quod maxime placeat facere possimus, omnis voluptas assumenda est, omnis dolor repellendus. Temporibus autem quibusdam et aut officiis debitis aut rerum necessitatibus saepe eveniet ut et voluptates repudiandae sint et molestiae non recusandae. Itaque earum rerum hic tenetur a sapiente delectus, ut aut reiciendis voluptatibus maiores alias consequatur aut perferendis doloribus asperiores repellat.`;
            let length = Math.round(Math.random()*loremIpsum.length/2);
            return loremIpsum.substring(0, length);
        }

        static randomUsers(count){
            for(var i=0; i<count; i++){
                let data = {};
                data.username = "annonymous";
                data.summary = loremIpsum;
                data.imgUrl = BASE_URL+"/frontend/img/unknownUser.png";

                Template.guestListWidget(data,'contactlist');
            }
        }

        static selectBotChat(conversationCount){
            var html = "";
            for(var i = 0; i<conversationCount; i++){
                let userData = {};
                let guestData = {};
               
                userData.username = sessionStorage.username;
                userData.text = Simulation.randomText();
                userData.imgUrl = BASE_URL+"/frontend/img/images.jfif";

                guestData.username = "Bot";
                guestData.text = Simulation.randomText();
                guestData.imgUrl = BASE_URL+"/frontend/img/unknownUser.png";

                html += Template.userChatBubble(userData);
                html += Template.guestChatBubble(guestData);

            }
            document.getElementById("msgConteiner").innerHTML = html;
            var elem =document.getElementById("msgConteiner");
            elem.style.scrollBehavior= "smooth";
            elem.scrollTop = elem.scrollHeight;
        }
    }

    class XHR{
        constructor(){
            this.xhr = new XMLHttpRequest();
        }

        Post(url, payload, callback){
            this.xhr.onreadystatechange  = () => {
                if (this.xhr.readyState == 4 && this.xhr.status == 200) {
                    let res =  this.xhr.responseText;
                    callback(res);
                    //if(!res.success){ alert("Something went wrong."); }
                }
            }
            this.xhr.open("POST", url); 
            this.xhr.setRequestHeader("Content-type", "application/json");
            this.xhr.setRequestHeader("Authorization", `Bearer ${sessionStorage.jwt}`);
            this.xhr.send(JSON.stringify(payload));
        }

        Put(url, payload, callback){
            this.xhr.onreadystatechange  = () => {
                if (this.xhr.readyState == 4 && this.xhr.status == 200) {
                    let res =  this.xhr.responseText;
                    callback(res);
                    //if(!res.success){ alert("Something went wrong."); }
                }
            }
            this.xhr.open("PUT", url); 
            this.xhr.setRequestHeader("Content-type", "application/json");
            this.xhr.setRequestHeader("Authorization", `Bearer ${sessionStorage.jwt}`);
            this.xhr.send(JSON.stringify(payload));
        }
    }

    class Service{
        constructor(){
            this.ajax = new XHR();
        }

        sendMessage(payload,callback){
            let url = BASE_URL+"/bot/api/v1.0/message/create";
            this.ajax.Post(url,payload,(res)=>{
                callback(res);
            });
        }

        getUserMessage(payload,callback){
            let url = BASE_URL+"/bot/api/v1.0/message/list";
            this.ajax.Post(url,payload,res=>{
                callback(res);
            });
        }

        getNewMessageCount(payload,callback){
            let url = BASE_URL+"/bot/api/v1.0/message/list";
            this.ajax.Post(url,payload,res=>{
                callback(res);
            });
        }

        messageRecieved(payload,callback){
            let url = BASE_URL+"/bot/api/v1.0/message/receivedby/update";
            this.ajax.Post(url,payload,res=>{
                callback(res);
            });
        }

        messageRead(payload,callback){
            let url = BASE_URL+"/bot/api/v1.0/message/readby/update";
            this.ajax.Post(url,payload,res=>{
                callback(res);
            });
        }

        getConversation(payload,callback){
            let url = BASE_URL+"/bot/api/v1.0/conversation/list";
            this.ajax.Post(url,payload,(res)=>{
                callback(res);
            });
        }

        createConversationID(payload,callback){
            let url = BASE_URL+"/bot/api/v1.0/conversation/create";
            this.ajax.Post(url,payload,(res)=>{
                callback(res);
            });
        }

        checkOnlineUser(payload,callback){
            let url = BASE_URL+"/bot/api/v1.0/onlineuser/check";
            this.ajax.Post(url,payload,(res)=>{
                callback(res);
            });
        }
    }

    class Controller{
        constructor(){
            this.service = new Service();
        }

        checkOnlineUser(payload,callback){
            this.service.checkOnlineUser(payload,res=>{
                callback(res);
            });
        }

        messageRecieved(payload,callback){
            this.service.messageRecieved(payload,res=>{
                callback(res);
            });
        }

        messageRead(payload,callback){
            this.service.messageRead(payload,res=>{
                callback(res);
            });
        }

        getChatData(recieverID,username,callback){
            this.service.getConversation(
                {
                    filters:{
                        platform: "DHSN",
                        userID: sessionStorage.userID, 
                    }  
                },(res)=>{
                    let json= JSON.parse(res);
                    for(var i = 0; i< json.data.conversations.length; i++){
                        if(json.data.conversations[i].user_to_data._id == recieverID){
                            var conversationID = json.data.conversations[i]._id;
                        }
                        if(json.data.conversations[i].user_from_data._id == recieverID){
                            var conversationID = json.data.conversations[i]._id;
                        }
                    }
                    
                    //console.log("typeof conversationID",typeof conversationID);
                    if(conversationID){
                        //console.log("conversationID : ", conversationID);
                        let payload = {
                            filters: {        
                                platform: "DHSN",
                                conversationID: conversationID,
                            },
                            sorting: { sortBy: "createdAt", mode: "ASC" }
                        };
                        this.service.getUserMessage(payload,(res)=>{
                            callback(res);
                        });
                    }else{
                        this.service.createConversationID({
                            conversation: {
                                from: sessionStorage.userID,
                                to: recieverID,
                                startDate: new Date().toISOString(),
                            },
                            platform: 'DHSN'
                        },(res)=>{
                            let data = JSON.parse(res).data;
                            let payload = {
                                filters: {        
                                    platform: "DHSN",
                                    conversationID: data.conversation._id,
                                },
                                sorting: { sortBy: "createdAt", mode: "ASC" }
                            };
                            this.service.getUserMessage(payload,(res)=>{
                                callback(res);
                            });
                        });
                    }
                 
            });
        }

        userOnline(recieverID,username,callback){
            this.getChatData(recieverID,username,res=>{
                callback(res);
            });
        }

        selectChat(recieverID,username){
            this.getChatData(recieverID,username,res=>{
                var messagelist = JSON.parse(res).data.messages;
                //console.log(messagelist);
                var html = "";
                for(var i = 0; i<messagelist.length; i++){
                    let msg = {};
                    if(messagelist[i].sender == sessionStorage.userID){
                        msg.username = sessionStorage.username;
                        msg.text = messagelist[i].text;
                        msg.imgUrl = "https://dev.chatbot.drezy.io/frontend/img/images.jfif";
                        html += Template.userChatBubble(msg);
                    }else{
                        msg.username = username;
                        msg.text = messagelist[i].text;
                        msg.imgUrl = "https://dev.chatbot.drezy.io/frontend/img/unknownUser.png";
                        html += Template.guestChatBubble(msg);
                    }
                }
                document.getElementById("msgConteiner").innerHTML = html;
                var elem =document.getElementById("msgConteiner");
                elem.style.scrollBehavior= "smooth";
                elem.scrollTop = elem.scrollHeight;
                
                //update message to read
                let unreadMessageID = [];
                messagelist.map(message=>{
                    if(message.status != "READ" && message.sender != sessionStorage.userID){
                        unreadMessageID.push(message._id);
                    }
                });
                //console.log("unreadMessageID.length : ",unreadMessageID.length);
                if(unreadMessageID.length>0){
                    this.service.messageRead({
                        messageIDs: unreadMessageID,
                        readBy:{
                            user:sessionStorage.userID,
                            readAt: new Date().toISOString()
                        }
                    },(res)=>{});
                }
            });
        }

        sendMessage(){
            let text = document.getElementById("textInput").value;
            document.getElementById("msgConteiner").insertAdjacentHTML(
                'beforeend', 
                Template.userChatBubble({
                    username: sessionStorage.username,
                    text: text,
                    imgUrl: "https://dev.chatbot.drezy.io/frontend/img/images.jfif"
                })
            );
            var elem =document.getElementById("msgConteiner");
            elem.style.scrollBehavior= "smooth";
            elem.scrollTop = elem.scrollHeight;
            
            let payload = {
                platform: "DHSN",
                to: sessionStorage.messageListener,
                message: {
                    sender: sessionStorage.userID,  
                    text: text,
                },
            }
            if(sessionStorage.messageListener!=="no one"){
                this.service.sendMessage(payload,res=>{
                    document.getElementById("textInput").value = "";
                });
            }
        }
    }

    
    class ChatApp{
        constructor(){
            this.controller = new Controller();
            this.validateLoginUser();
            this.socket = io(SOCKET_URL,{
                auth: {
                    username: this.username,
                    refID: this.refID, 
                    userID: this.userID
                },
                transports: ["websocket", "polling"],
                autoConnect: false,
                path: '/bot/socketIO/'
            });
            this.controller.checkOnlineUser({
                    refID : this.refID
                },(res)=>{
                    let data = JSON.parse(res).data;
                    //console.log("socketOccupied : ",data);
                    if(data.socketOccupied == false){
                        this.startSocket();
                    }else{
                        alert("socket Occupied : please liaise with your colleague.");
                        window.location = BASE_URL+"/frontend/index.html";
                    }
            });
            sessionStorage.setItem('messageListener','no one');
            
        }

        validateLoginUser(){
            if( sessionStorage.getItem('userID') !== null){
                this.username =  sessionStorage.getItem('username');
                this.userID =  sessionStorage.getItem('userID');
                this.refID =  sessionStorage.getItem('refID');
                document.getElementById("displayName").innerHTML = this.username;
            }else{
                window.location = BASE_URL+"/frontend/index.html";
            }
        }

        checkOnlineUser(){
            this.controller.getOnlineUser({},(res)=>{
                let data = JSON.parse(res);
                if(data.success == true){
                    let onlineusers = data.data;
                    onlineUsers = onlineusers.filter(user=>user.userID !== sessionStorage.userID);
                    this.loadUsers(onlineUsers);
                }
            });
        }

        startSocket(){
            
            if(this.socket.disconnected){
                this.socket.connect();
            }

            this.socket.on("private_message", data => {
                //console.log("%cObject :","color:blue;",data);
                    //append new message to text screen
                    let msg = {};
                    msg.username = document.getElementById("chat-"+data.senderID).getAttribute("data-username");
                    msg.imgUrl = "https://dev.chatbot.drezy.io/frontend/img/unknownUser.png";
                    msg.text = data.text;
                    //console.log(msg);
                    let userType = (sessionStorage.userID==data.senderID)? "bot" : "GuesT";
                    //console.log(userType);
                    let template = (sessionStorage.userID==data.senderID)? Template.botChatBubble(msg): Template.guestChatBubble(msg);

                    //console.log("chat selected : ",data.senderID == sessionStorage.messageListener);
                    if( data.senderID == sessionStorage.messageListener){
                        setTimeout(() => {
                            document.getElementById("msgConteiner").insertAdjacentHTML('beforeend',template);
                            var elem =document.getElementById("msgConteiner");
                            elem.style.scrollBehavior= "smooth";
                            elem.scrollTop = elem.scrollHeight;

                            this.selectChat(data.senderID,msg.username)
                        }, 1000);
                    }
            });

            this.socket.on("user_online", list => {
                //console.log("list : ",list);
                Template.botUser();
                if(list.length>0){
                    this.onlineUsers = list.filter(user=>user.userID !== sessionStorage.userID);
                    this.loadUsers(this.onlineUsers);
                }
            });

            this.socket.on("user_offline", offlineuser =>{
                console.log("offline userID : ",offlineuser);
                console.log("b4 : ", this.onlineUsers);
                    this.onlineUsers = this.onlineUsers.filter(user=>user.userID != offlineuser.userID);
                    console.log("After : ",this.onlineUsers)
                    Template.botUser();
                    this.loadUsers(this.onlineUsers);
            });

        }

        loadUsers(list,i=0){ 
            //console.log("contact list",list[i].username);
            this.controller.userOnline(list[i].userID,list[i].username, res=>{
                //render side widget
                //console.log(JSON.parse(res).data.messages);
                let messagelist = JSON.parse(res).data.messages; 
                let unreadMessageCount = 0;
                let msg = {}; 
                msg.time = ""; 
                if(messagelist[messagelist.length-1]){
                    let time = messagelist[messagelist.length-1].createdAt;
                    time = time.split("T")[1];
                    time = time.split(":");
                    let hour = parseInt(time[0]) + 8; //malaysia GMT+8
                    hour = (hour>=24)? hour - 24: hour;
                    hour = (hour < 10 )? "0"+hour:hour;
                    let minute = time[1];
                    msg.time = `${hour}:${minute}`;
                }
                msg.text = (messagelist[messagelist.length-1]) ? messagelist[messagelist.length-1].text : "";
                msg.sender = (messagelist[messagelist.length-1])?  messagelist[messagelist.length-1].sender : list[i].userID;
                msg.username = list[i].username;
                msg.userID = list[i].userID;
                messagelist.map(message=>{ 
                    if(message.status != "READ" && message.sender != sessionStorage.userID){ 
                        unreadMessageCount++ 
                    }
                });
                msg.unreadMessageCount = unreadMessageCount;
                Template.updateOnlineUser(msg);
                //update message recieved
                let unreadMessageID = [];
                messagelist.map(message=>{
                    if(message.status == "SENT" && message.sender != sessionStorage.userID){
                        unreadMessageID.push(message._id);
                    }
                });
                if(unreadMessageID.length>0){
                    this.controller.messageRecieved({
                        messageIDs: unreadMessageID,
                        receivedBy:{
                            user:sessionStorage.userID,
                            receivedAt: new Date().toISOString()
                        }
                    },res=>{});
                }
                //self call in the callback
                if(i<list.length - 1){
                    i++;
                    this.loadUsers(list, i);
                }
            }); 
        }

        selectChat(selectedUser,username){
            document.getElementById("chatUser").innerHTML = username;
            sessionStorage.setItem("messageListener" , selectedUser);
            if(selectedUser == sessionStorage.userID){
                Simulation.selectBotChat(4);
            }else{
                this.controller.selectChat(selectedUser,username);
            }
        }

        enterSendMessage(event){
            if (event.key === 'Enter' || event.keyCode === 13) {
                this.controller.sendMessage();
            }
        }

        sendMessage(){
            this.controller.sendMessage();
        }

        logout(){
            sessionStorage.removeItem('userID');
            sessionStorage.removeItem('refID');
            sessionStorage.removeItem('username');
            sessionStorage.removeItem('jwt');
            sessionStorage.removeItem('messageListener');

           this.socket.off();
 
            window.location = BASE_URL+"/frontend/index.html"
        }
    }
    
    const app = new ChatApp();


    class Template{
        static guestListWidget(data,elementID){
            data.summary = (data.summary.length>80) ? data.summary.substring(0, 80)+ '...': data.summary;
            
            let template = `
                <a href="#" onclick = "app.selectChat('${data.userID}'','${data.username}')">
                    <div class="contact-widget m-1 d-flex">
                        <div class="d-flex align-items-center justify-content-center" style="width:30%; height:100%">
                            <img src="${data.imgUrl}" class="guest-img">
                        </div>
                        <div style="width:70%; text-align: left;">
                            <div class="ms-1 mt-2"><b>${data.username}</b></div>
                            <p class="ms-1 summary">${data.summary}</p>
                        </div>
                    </div>
                </a>
            `;
            document.getElementById(elementID).insertAdjacentHTML('beforeend',template);
        }

        static userChatBubble(data){
            let template = `
            <div class="ms-1 mt-2 d-flex justify-content-end align-items-center">
                <b>${data.username}</b>
                <img class="img-sm m-1" src='${data.imgUrl}'>
            </div>
            <div class="d-flex justify-content-end">
                <div class="chat-bubble-user m-1 d-flex">
                    <div style="width:100%; text-align: left;">
                        <p class="m-0 message">${data.text}</p>
                    </div>
                </div>
            </div>`;
            return template;
        }

        static guestChatBubble(data){
            let template = `
            <div class="ms-1 mt-2 d-flex justify-content-start align-items-center">
                <img class="img-sm m-1" src='${data.imgUrl}'>
                <b>${data.username}</b>
            </div>
            <div class="d-flex justify-content-start">
                <div class="chat-bubble-guest m-1 d-flex">
                    <div style="width:100%; text-align: left;">
                        <p class="m-0 message">${data.text}</p>
                    </div>
                </div>
            </div>
            `;
            return template;
        }

        static botChatBubble(data){
            let template = `
            <div class="ms-1 mt-2 d-flex justify-content-start align-items-center">
                <img class="img-sm m-1" src="${BASE_URL}/frontend/img/bot-icon.png">
                <b>Bot</b>
            </div>
            <div class="d-flex justify-content-start">
                <div class="chat-bubble-guest m-1 d-flex">
                    <div style="width:100%; text-align: left;">
                        <p class="m-0 message">${data.text}  yourself</p>
                    </div>
                </div>
            </div>
            `;
            return template;
        }

        static botUser(){
            let template = `
                <div class="contact-widget d-flex m-1">
                    <div class="d-flex align-items-center justify-content-center" style="width:30%; height:100%">
                        <img src="${BASE_URL}/frontend/img/bot-icon.png" class="guest-img">
                    </div>
                    <div style="width:70%;" onclick = "app.selectChat('${sessionStorage.userID}','${sessionStorage.username}');">
                        <div class="ms-1 mt-2 d-flex">
                            <span class="justify-content-start" style="width:80%"><b>Bot</b></span>
                            <span class="justify-content-end" style="width:20%; margin-right:10px;"><b>4.30</b></span>    
                        </div>
                        <div class="ms-1 mt-2 d-flex">
                            <span class="justify-content-start" style="width:80%"><p class="ms-1 summary">Hello</p></span>
                            <span style="width:20%">
                                <div class="justify-content-end">
                                    <b></b>
                                </div>
                            </span>
                        </div>
                    </div>
                </div>
            `;
            document.getElementById("contactlist").innerHTML = "";
            document.getElementById("contactlist").insertAdjacentHTML('beforeend',template);
        }

        static updateOnlineUser(data){
            let newMsg = (data.unreadMessageCount == 0)?``:`
            <span style="width:20%;">
                <div class="justify-content-end newMessageCount">
                    <b>${data.unreadMessageCount}</b>
                </div>
            </span>`;

            let time = (data.unreadMessageCount == 0)?`<span class="justify-content-end" style="width:20%; margin-right:10px;"><b>${data.time}</b></span>`:`<span class="justify-content-end newMessageTime" style="width:20%; margin-right:10px;"><b>${data.time}</b></span>`;

            let template2 = `
            <div class="contact-widget d-flex m-1" onclick = "app.selectChat('${data.userID}','${data.username}');" id="chat-${data.userID}" data-username="${data.username}">
                <div class="d-flex align-items-center justify-content-center" style="width:30%; height:100%">
                    <img src="${BASE_URL}/frontend/img/unknownUser.png" class="guest-img">
                </div>
                <div style="width:70%; text-align: left;">
                    <div class="ms-1 mt-2 d-flex">
                        <span class="justify-content-start" style="width:80%"><b>${data.username}</b></span>
                        ${time}  
                    </div>
                    <div class="ms-1 mt-2 d-flex">
                        <span class="justify-content-start" style="width:80%"><p class="ms-1 summary">${data.text}</p></span>
                        ${newMsg}
                    </div>
                </div>
            </div>
            `;
            document.getElementById("contactlist").insertAdjacentHTML('beforeend',template2);
        }
    }
</script>
<script src="https://dev.chatbot.drezy.io/frontend/asset/frontend/asset/Bootstrap5/Bootstrap5.js"></script>
<style>
    .newMessageTime{
        color: rgb(20, 227, 241);
    }
    .newMessageCount{
        background-color: rgb(20, 227, 241);
        color: rgb(31, 28, 28);
        width: 20px;
        height: 20px;
        text-align: center;
        border-radius: 50%;
        font-size: 12px;
    }
    .displayPicture{
        height: 100px;
        width: 100px;
        border-radius: 50%;
    }
    .guest-img{
        height: 80px;
        width: 80px;
        border-radius: 50%; 
        border: 1px solid #aaaaaaaa;
    }
    .img-sm{
        height: 15px;
        width: 15px;
        border-radius: 50%;
    }
    .contact-widget{
        height: 110px;
        width:95%;
        background-color: white;
        color:black;
    }
    #contactlist a{
        text-decoration: none;
    }
    .chat-bubble-user{
        background-color: black;
        color:white;
        text-align: right;
        max-width: 60%;
        padding:15px;
        border-radius: 15px;
    }
    .chat-bubble-guest{
        background-color: #aaaaaaaa;
        color:black;
        text-align: left;
        max-width: 60%;
        padding:15px;
        border-radius: 15px;
    }
    .msg-container{
        background-color: rgba(225,225,225,0.7);
        width: 90%;
        height: 550px;
        overflow-y: auto;
    }
    .logout{
        cursor: pointer;
        background-color: white;
        padding: 5px;
        margin: 2px;
        border-radius: 50%;
        color: #f03838;
    }
</style>